#ifndef SPIN_H
#define SPIN_H

enum
{
	NUM_NODES = 3,          //Total number of nodes.  Make sure that the packet length is large enough in the Makefile.
	TIMEOUT_MILLI = 35,     //Wait for a packet from node k for this long before moving on.
	TX_POWER = 0,          //Transmission power of each packet.  MAX = 31.
	ENABLE_LEDS = TRUE,     //Enable the LED blinking
	BATTERY_LOW = 3840,      //Battery is low if internal voltage below this threshold. Vsoltage = N/4096*3.
    AM_RSSIMSG = 6,
	AM_STARTMSG = 5,
};

typedef nx_struct StartMsg
	{
		nx_uint8_t nodeid;
	} StartMsg;

typedef nx_struct radioMsg
{
	nx_uint8_t nodeid;
	nx_uint8_t RSSI[NUM_NODES];
} radioMsg;

#endif
