import java.io.IOException;
import java.io.PrintWriter;
import java.io.FileWriter;
import java.io.BufferedWriter;
import net.tinyos.message.*;
import net.tinyos.packet.*;
import net.tinyos.util.*;
import org.jfree.chart.*;
import org.jfree.chart.plot.XYPlot;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.data.xy.XYDataset;
import org.jfree.data.xy.XYSeries;
import org.jfree.data.xy.XYSeriesCollection;
import org.jfree.chart.renderer.xy.XYDotRenderer;
import java.util.Random;

public class RssiSerial implements MessageListener {

  private MoteIF moteIF;
    private String namefile;
    private PrintWriter fileOut;
    private XYSeries[] array; 	  
    private boolean reset;
    public int number_anchor;  

    public RssiSerial(MoteIF moteIF,PrintWriter fileOut,XYSeries[] array,int number_anchor) {
    this.moteIF = moteIF;
    this.moteIF.registerListener(new RssiSerialMsg(), this);
    this.fileOut=fileOut;
    this.array=array;
    this.reset=true;
    this.number_anchor=number_anchor;
    }
  public void messageReceived(int to, Message message) {
	int nodeid=0;
	int NUM_NODES = number_anchor + 1;
	RSSIArray = new int[NUM_NODES];
	  
	RssiSerialMsg msg = (RssiSerialMsg)message;
    	if(msg==null) return;
	try{
	   nodeid=msg.get_nodeid();
	   for(i=0; i<NUM_NODES; i++)
		   RSSIArray[i] = msg.get_RSSI[i];    // NON SO COME FARE QUESTO!!!!!
	}catch(Exception ee){
	    return;
	} 
  
  
	if(nodeid>number_anchor || nodeid<1){
		System.out.println("RICEVUTA RICHIESTA DA ANCORA SCONOSCIUTA");
		return;	
	}
     array[(nodeid-1)*2].add(seqnum,rssi1);
     array[((nodeid-1)*2)+1].add(seqnum,rssi2);	
     System.out.println(nodeid+"\t"+RSSIArray);	
     fileOut.println(nodeid+"\t"+RSSIArray);
     fileOut.flush();
}
   public static void main(String[] args) throws Exception {
    int visualized=100;
    String source = args[1];
    String namefile=null;
    int number_anchor=2;
    if(args[2].equals("-f"))namefile=args[3];
    if(args[4].equals("-n"))number_anchor=((Integer)(Integer.parseInt(args[5]))).intValue();
    XYSeries[] array=new XYSeries[2*number_anchor]; 
    PrintWriter fileOut = fileOut = new PrintWriter(new BufferedWriter(new FileWriter(namefile,false)));   
   
       PhoenixSource phoenix;
    
       if (source == null) {
	   phoenix = BuildSource.makePhoenix(PrintStreamMessenger.err);
       }
       else {
          phoenix = BuildSource.makePhoenix(source, PrintStreamMessenger.err);
       }
       MoteIF mif = new MoteIF(phoenix);
       XYDataset dataset = new XYSeriesCollection();
       for(int i=0;i<number_anchor;i++)
       {
	 
          array[(i*2)]=new XYSeries("RSS@User from anchor "+(i+1));
   	   array[(i*2)].setMaximumItemCount(visualized);
           ((XYSeriesCollection) dataset).addSeries(array[(i*2)]);	
	    array[(i*2)+1]=new XYSeries("RSS@Anchor "+(i+1));	
	   ((XYSeriesCollection) dataset).addSeries(array[(i*2)+1]);
	    array[(i*2)+1].setMaximumItemCount(visualized);		
	}
	JFreeChart chart = ChartFactory.createXYLineChart(
"Rss ", "Packet sequence number", "RSS", dataset,
				PlotOrientation.VERTICAL, true, false, false);
       	chart.setAntiAlias(true);
        ChartFrame chf = new ChartFrame("Rss", chart);
	chf.setSize(800, 600);
	chf.setVisible(true);
	//if you uncomment you see the chart as point but I think that is better as line
        //XYPlot xyPlot = (XYPlot) chart.getPlot();
        //XYDotRenderer xd=new XYDotRenderer();
        //xyPlot.setRenderer( 0, xd );
	RssiSerial serial = new RssiSerial(mif,fileOut,array,number_anchor);
       	
    }
}
