import java.io.IOException;
import net.tinyos.message.*;
import net.tinyos.packet.*;
import net.tinyos.util.*;



//
import org.jfree.chart.*;
import org.jfree.chart.plot.XYPlot;
import org.jfree.chart.plot.PlotOrientation;
import org.jfree.data.xy.XYDataset;
import org.jfree.data.xy.XYSeries;
import org.jfree.data.xy.XYSeriesCollection;
import org.jfree.chart.renderer.xy.XYDotRenderer;

//


public class TestSerial implements MessageListener {

	  private MoteIF moteIF;
	  
	  public TestSerial(MoteIF moteIF) {
	    this.moteIF = moteIF;
	    this.moteIF.registerListener(new TestSerialMsg(), this);
	  }
	  
	  private static void usage() {
		    System.err.println("usage: TestSerial [-comm <source>]");
		  }
	  
	  public void messageReceived(int to, Message message) {
		    TestSerialMsg msg = (TestSerialMsg)message;
		    System.out.print(msg.get_nodeid()+"\t");
		    short[] rssi = msg.get_RSSI();
		    for(short rss: rssi){
		    	System.out.print(rss+"\t");
		    }
		    System.out.println();
	
	  }
	  
	  public static void main(String[] args) throws Exception {
		  
		  
		  //
		  int number_anchor=5;
		  XYSeries[] array=new XYSeries[2*number_anchor]; 
		  //
		  
		  String source = null;
		    System.out.println("hello");
		    if (args.length == 2) {
		      if (!args[0].equals("-comm")) {
			usage();
			System.exit(1);
		      }
		      source = args[1];
		    }
		    else if (args.length != 0) {
		      usage();
		      System.exit(1);
		    }

		    PhoenixSource phoenix;
		    
		    if (source == null) {
		      phoenix = BuildSource.makePhoenix(PrintStreamMessenger.err);
		    }
		    else {
		      phoenix = BuildSource.makePhoenix(source, PrintStreamMessenger.err);
		    }

		    System.out.println("goodbye");
		    MoteIF mif = new MoteIF(phoenix);
		    TestSerial serial = new TestSerial(mif);
		  
		  
		  //
		  for(int i=0;i<number_anchor;i++)
		  {
			  
			  array[(i*2)]=new XYSeries("RSS@User from anchor "+(i+1));
			  array[(i*2)].setMaximumItemCount(visualized);
			  ((XYSeriesCollection) dataset).addSeries(array[(i*2)]);	
			  array[(i*2)+1]=new XYSeries("RSS@Anchor "+(i+1));	
			  ((XYSeriesCollection) dataset).addSeries(array[(i*2)+1]);
			  array[(i*2)+1].setMaximumItemCount(visualized);		
		  }
		  JFreeChart chart = ChartFactory.createXYLineChart("Rss ", "Packet sequence number", "RSS", dataset,PlotOrientation.VERTICAL, true, false, false);
		  chart.setAntiAlias(true);
		  ChartFrame chf = new ChartFrame("Rss", chart);
		  chf.setSize(800, 600);
		  chf.setVisible(true);
		  //if you uncomment you see the chart as point but I think that is better as line
		  //XYPlot xyPlot = (XYPlot) chart.getPlot();
		  //XYDotRenderer xd=new XYDotRenderer();
		  //xyPlot.setRenderer( 0, xd );
		  
		  
		  //
		  
		  
		  
		  
		  
		  
		  
		  }

}